From 0d3b12c5f42037b5222b27d984c4d8a768e1a2cf Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 28 Nov 2011 12:32:38 -0600
Subject: Retain original aggcoef is extra credit is checked

---
 grade/edit/tree/index.php |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/grade/edit/tree/index.php b/grade/edit/tree/index.php
index e1328f8..a1820c6 100644
--- a/grade/edit/tree/index.php
+++ b/grade/edit/tree/index.php
@@ -297,13 +297,15 @@ if ($data = data_submitted() and confirm_sesskey()) {
 
             // Weighted Mean special case
             $parent = $grade_item->load_parent_category();
+
             if ($parent->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN) {
                 $oldcoef = $grade_item->aggregationcoef;
 
+                // Retain original aggregationcoef if extra credit checked
                 if ($oldcoef < 0 and !$value) {
-                    $grade_item->aggregationcoef = 0;
+                    $grade_item->aggregationcoef = $oldcoef * -1;
                 } else {
-                    $grade_item->aggregationcoef = $value ? -1 : $oldcoef;
+                    $grade_item->aggregationcoef = $value ? abs($oldcoef) * -1 : $oldcoef;
                 }
             } else {
                 $grade_item->aggregationcoef = $value;
-- 
1.7.1


